<script lang="ts">
  import FileItem from '$lib/components/Items/FileItem.svelte';

  export let label: string,
    name: string,
    multiple = false,
    files: FileList | null = null;

  function handleRemove(event: CustomEvent<File>) {
    if (files) {
      const fileToRemove = event.detail,
        dataTransfer = new DataTransfer();

      for (const file of files) {
        if (file !== fileToRemove) {
          dataTransfer.items.add(file);
        }
      }

      files = dataTransfer.files;
    }
  }
</script>

<section>
    <label class="mb-3 lg:mb-5 block text-xl space-y-1 cursor-pointer">
        <span class="mb-1 lg:mb-1.5">{label}</span>

        {#if !(files && files.length)}
            <span class="text">Добавить файлы</span>
        {:else}
            {#if multiple}
                <span class="text">Добавить файлы</span>
            {/if}
        {/if}

        <input type="file" {name} class="hidden" bind:files {multiple}>
    </label>
    {#if files}
        <section class="space-y-2">
            {#each Array.from(files) as file}
                <FileItem {file} on:remove={handleRemove}/>
            {/each}
        </section>
    {/if}
</section>

<style lang="postcss">
    .text {
        @apply appearance-none transition duration-200 outline-none
        border-2 border-dashed border-gray-300
        p-8 rounded-3xl w-full block text-center text-neutral-600
        hover:underline decoration-2 decoration-blue-700
        focus-within:border-blue-700 focus-within:bg-white;
    }
</style>